/*
   Naunidh Singh Chadha and Girindar Singh.
   Amity School Of Eng. & Technology,Delhi.
   ( B.Tech VIyr ) Information Technology.
   ph:9810127669(N), 9811007011(G)
   naunidhbaba@yahoo.com,girindar@yahoo.com.

   No specific assumptions about the problem have been made, We
   have tried to follow the given guidelines closely.
   The input file is given as a command line argument,
   A sample i/p file  has been provided, it strictly adhers to
   the prescribed format.
   An inconsistent data might give a parsing error,
   but an extensive error handling for this job has not been provided.
   Output is displayed on the console in the format as demanded.
   It has not been stored in a file as the question DIDNT ask us to
   do that.
   <<<<<< about the i/p file >>>>>>>
   everyline must end with a crlf and numbers should not be greater than
   |10| and a # is MUST
 */
#include<fstream.h>
#include <conio.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<iomanip.h>

 //data structures
 int num=0;//number of players
 char name[4][15]; //names of the players
 int score[4][9][12];
 // score of each player(1st col), with each row for one line of input.

int max (int arr[4],int len)
{
	int ind=0,high=-1;
	for (int i=0;i<len;i++)
		  if (arr[i]>high) {high=arr[i];ind=i;}
	return ind;
}

int convert (char arr[36],int i,int j)
{
	// i is player num, j is line number and k is the score of each shot.

	char tmp[7]="  ";int k=0;
	int len=strlen(arr);
	//cout<<"*"<<arr<<"!"<<len<<endl;
	for (int l=0;l<len;l++)
	{
	  int c2=0;
	  while(arr[l]!=' '&& c2<6)
	  {
		tmp[c2]=arr[l];
		c2++;l++;
	  }

	  tmp[c2]=(char)0;
	  score[i][j][k]=atoi(tmp);k++;
	  //cout<<score[i][j][k-1]<<" ";
	  }
	cout<<endl;
	return k-1;
}

void main(int argc,char **argv)
{
 clrscr();
 //Init score
 for (int i=0;i<4;i++)
 for (int j=0;j<9;j++)
 for (int k=0;k<12;k++)	score[i][j][k]=-11; //default value
 if (argc!=2){cout<<"\nParameter missing: Fatal!!";
			  cout<<"\nUsage : DUCKPIN filename";exit(-1);}
 fstream f1(argv[1],ios::in);
 if (!f1) {cout<<"\nFile Init Error:Fatal !!";exit(-1);}

 //get the number of players
 char x;
 f1.read((char*)&x,sizeof(num));
 num=atoi(&x);
 //cout<<num<<endl;
 //get the names
 for (i=0;i<num;i++)
 {
	f1.getline(name[i],10);
	//cout<<name[i]<<endl;
 }

 //now get the input lines for game 1
 char temp [50];

 for (int m=0;m<3;m++)
 {
 for (int i=0;i<num;i++)
 {
	for (int j=0;j<3;j++)
	{
		f1.getline(temp,46);
		convert(temp,i,j+m*3);
	}
 }
 f1.getline(&x,10);
 if (x!='#') {cout<<"\nParsing Error:Fatal !!";exit(-1);}
}


// Calculations based on the input.


int matsco[4][3][10]; //4 players 3 matches 10 frames<<complete score>>

for (m=0;m<3;m++)
{
for (i=0;i<num;i++)
{
  int sco=0,c1=0,c2=0,c3=0,frame=0;

  while (frame<10)
  {
	  if (frame!=0) matsco[i][m][frame-1]=sco;
	  sco=0;

	//spl last frame case
	if (frame==9)
	{
	  //strike
	  if (score[i][0+m*3][c1]==10)
	  {
	  sco+=10;c1++;
	  if (score[i][0+m*3][c1]>=0) {sco+=score[i][0+m*3][c1];c1++;}
	  else {frame++;continue;}
	  if (score[i][0+m*3][c1]>=0) {sco+=score[i][0+m*3][c1];}
	  else {frame++;continue;}
	  }

	  else if ((score[i][0+m*3][c1]+score[i][1+m*3][c2])==10) //is spare
	  {
	  sco+=10;c1++;c2++;
	  if (score[i][0+m*3][c1]>=0) {sco+=score[i][0+m*3][c1];}
	  else {frame++;continue;}
	  }

	 else //normal case
	  {
	  if (score[i][0+m*3][c1]>=0) {sco+=score[i][0+m*3][c1];}
	  if (score[i][1+m*3][c2]>=0) {sco+=score[i][1+m*3][c2];}
	  if (score[i][2+m*3][c3]>=0) {sco+=score[i][2+m*3][c3];}
	  }

	 frame++;continue;
	}

	//is strike
	if (score[i][0+m*3][c1]==10 && frame<9) //last frame is special
	{
	  sco+=10;c1++;
	  if (score[i][0+m*3][c1]>=0) {sco+=score[i][0+m*3][c1];}
	  else {frame++;continue;} //foul no need to go further
	  //SPL CASE FOR STRIKE-STRIKE NEEDS TO BE ENCOUNTERED
	  if (score[i][0+m*3][c1]!=10){
	  if (score[i][1+m*3][c2]>0 )  {sco+=score[i][1+m*3][c2];}
	  else {frame++;continue;} //foul
	  }
	  else
	  {
	  if (score[i][0+m*3][c1+1]>0 )  {sco+=score[i][0+m*3][c1+1];}
	  else {frame++;continue;} //foul
	  }
	  frame++;continue;
	}

	int tmp=score[i][0+m*3][c1];
	//is first shot foul
	if (tmp<0) //yes
	{ c1++;frame++;continue;}

	//is shot2 foul
	int tmp2=score[i][1+m*3][c2];
	if (tmp2<0) //yes
	{ c2++;sco+=tmp;frame++;continue;}

	//is spare
	if ((tmp+tmp2)==10 && frame <9)
	{
		sco+=10;c1++;c2++;  //next strike is on line 1
		if (score[i][0+m*3][c1]>0)  {frame++;sco+=score[i][0+m*3][c1];}
		else {frame++;continue;} //foul
	 }
	 else
	 {
	   sco+=(tmp+tmp2+score[i][2+m*3][c3]);frame++;
	   c1++;c2++;c3++;
	 }

 }// end of while
 matsco[i][m][frame-1]=sco;

 } //end of sec for

}//end of top for

 //Printing and stuff
 int tmpsco[4],flag[4];
 for (	m=0;m<3;m++)
 {
	for (i=0;i<num;i++)
	{
		flag[i]=0;
		cout<< setiosflags(ios::left)<<setw(10);
		cout<<endl<<name[i];
		for (j=0;j<10;j++)
		{
		  cout<< setiosflags(ios::right)<<setw(4);
		  cout<<matsco[i][m][j];
		  tmpsco[i]=matsco[i][m][j];
		}
		flag[i]=flag[i]+tmpsco[i];
		cout<<endl;
	}
	//find the highest score
	int ret=max(tmpsco,num);

	cout<<"\nWinner for match "<<m<<"  : "<<name[ret]<<endl;
 }
 int ret=max(tmpsco,num);
	cout<<"\n\nTournament Winner is : "<<name[ret]<<endl;

getch();
f1.close();

}
